<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>CsvOutputArchive.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute</a> &gt; <span class="el_source">CsvOutputArchive.java</span></div><h1>CsvOutputArchive.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.io.UnsupportedEncodingException;
import java.util.List;
import java.util.TreeMap;

/**
 *
 */
public class CsvOutputArchive implements OutputArchive {

    private PrintStream stream;
<span class="fc" id="L34">    private boolean isFirst = true;</span>
    
    static CsvOutputArchive getArchive(OutputStream strm)
    throws UnsupportedEncodingException {
<span class="nc" id="L38">        return new CsvOutputArchive(strm);</span>
    }
    
    private void throwExceptionOnError(String tag) throws IOException {
<span class="pc bpc" id="L42" title="1 of 2 branches missed.">        if (stream.checkError()) {</span>
<span class="nc" id="L43">            throw new IOException(&quot;Error serializing &quot;+tag);</span>
        }
<span class="fc" id="L45">    }</span>
 
    private void printCommaUnlessFirst() {
<span class="fc bfc" id="L48" title="All 2 branches covered.">        if (!isFirst) {</span>
<span class="fc" id="L49">            stream.print(&quot;,&quot;);</span>
        }
<span class="fc" id="L51">        isFirst = false;</span>
<span class="fc" id="L52">    }</span>
    
    /** Creates a new instance of CsvOutputArchive */
    public CsvOutputArchive(OutputStream out)
<span class="fc" id="L56">    throws UnsupportedEncodingException {</span>
<span class="fc" id="L57">        stream = new PrintStream(out, true, &quot;UTF-8&quot;);</span>
<span class="fc" id="L58">    }</span>
    
    public void writeByte(byte b, String tag) throws IOException {
<span class="nc" id="L61">        writeLong((long)b, tag);</span>
<span class="nc" id="L62">    }</span>
    
    public void writeBool(boolean b, String tag) throws IOException {
<span class="fc" id="L65">        printCommaUnlessFirst();</span>
<span class="pc bpc" id="L66" title="1 of 2 branches missed.">        String val = b ? &quot;T&quot; : &quot;F&quot;;</span>
<span class="fc" id="L67">        stream.print(val);</span>
<span class="fc" id="L68">        throwExceptionOnError(tag);</span>
<span class="fc" id="L69">    }</span>
    
    public void writeInt(int i, String tag) throws IOException {
<span class="fc" id="L72">        writeLong((long)i, tag);</span>
<span class="fc" id="L73">    }</span>
    
    public void writeLong(long l, String tag) throws IOException {
<span class="fc" id="L76">        printCommaUnlessFirst();</span>
<span class="fc" id="L77">        stream.print(l);</span>
<span class="fc" id="L78">        throwExceptionOnError(tag);</span>
<span class="fc" id="L79">    }</span>
    
    public void writeFloat(float f, String tag) throws IOException {
<span class="nc" id="L82">        writeDouble((double)f, tag);</span>
<span class="nc" id="L83">    }</span>
    
    public void writeDouble(double d, String tag) throws IOException {
<span class="nc" id="L86">        printCommaUnlessFirst();</span>
<span class="nc" id="L87">        stream.print(d);</span>
<span class="nc" id="L88">        throwExceptionOnError(tag);</span>
<span class="nc" id="L89">    }</span>
    
    public void writeString(String s, String tag) throws IOException {
<span class="fc" id="L92">        printCommaUnlessFirst();</span>
<span class="fc" id="L93">        stream.print(Utils.toCSVString(s));</span>
<span class="fc" id="L94">        throwExceptionOnError(tag);</span>
<span class="fc" id="L95">    }</span>
    
    public void writeBuffer(byte buf[], String tag)
    throws IOException {
<span class="fc" id="L99">        printCommaUnlessFirst();</span>
<span class="fc" id="L100">        stream.print(Utils.toCSVBuffer(buf));</span>
<span class="fc" id="L101">        throwExceptionOnError(tag);</span>
<span class="fc" id="L102">    }</span>
    
    public void writeRecord(Record r, String tag) throws IOException {
<span class="pc bpc" id="L105" title="1 of 2 branches missed.">        if (r == null) {</span>
<span class="nc" id="L106">            return;</span>
        }
<span class="fc" id="L108">        r.serialize(this, tag);</span>
<span class="fc" id="L109">    }</span>
    
    public void startRecord(Record r, String tag) throws IOException {
<span class="pc bpc" id="L112" title="1 of 4 branches missed.">        if (tag != null &amp;&amp; !&quot;&quot;.equals(tag)) {</span>
<span class="fc" id="L113">            printCommaUnlessFirst();</span>
<span class="fc" id="L114">            stream.print(&quot;s{&quot;);</span>
<span class="fc" id="L115">            isFirst = true;</span>
        }
<span class="fc" id="L117">    }</span>
    
    public void endRecord(Record r, String tag) throws IOException {
<span class="pc bpc" id="L120" title="1 of 4 branches missed.">        if (tag == null || &quot;&quot;.equals(tag)) {</span>
<span class="fc" id="L121">            stream.print(&quot;\n&quot;);</span>
<span class="fc" id="L122">            isFirst = true;</span>
        } else {
<span class="fc" id="L124">            stream.print(&quot;}&quot;);</span>
<span class="fc" id="L125">            isFirst = false;</span>
        }
<span class="fc" id="L127">    }</span>
    
    public void startVector(List v, String tag) throws IOException {
<span class="fc" id="L130">        printCommaUnlessFirst();</span>
<span class="fc" id="L131">        stream.print(&quot;v{&quot;);</span>
<span class="fc" id="L132">        isFirst = true;</span>
<span class="fc" id="L133">    }</span>
    
    public void endVector(List v, String tag) throws IOException {
<span class="fc" id="L136">        stream.print(&quot;}&quot;);</span>
<span class="fc" id="L137">        isFirst = false;</span>
<span class="fc" id="L138">    }</span>
    
    public void startMap(TreeMap v, String tag) throws IOException {
<span class="nc" id="L141">        printCommaUnlessFirst();</span>
<span class="nc" id="L142">        stream.print(&quot;m{&quot;);</span>
<span class="nc" id="L143">        isFirst = true;</span>
<span class="nc" id="L144">    }</span>
    
    public void endMap(TreeMap v, String tag) throws IOException {
<span class="nc" id="L147">        stream.print(&quot;}&quot;);</span>
<span class="nc" id="L148">        isFirst = false;</span>
<span class="nc" id="L149">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>